let array = [4, 8, 12, 16];

// foreach
// array.forEach(function(item) {
//     console.log(item);
// });

Array.prototype.selfForEach = function(callback) {
    for (let i = 0; i < this.length; i++) {
        callback(this[i], i, this);
    }
};

function forEachCallback(item, index, originalArray) {
    // console.log(item);
    // console.log(index);
    // console.log(originalArray);
}

array.selfForEach(forEachCallback);

let newArray = array.map(function(item, index, originalArray) {
    return item * 2;
});

Array.prototype.selfMap = function(callback) {
    let map = [];
    for (let i = 0; i < this.length; i++) {
        map.push(callback(this[i], i, this));
    }
    return map;
};

function mapCallback(item, index, originalArray) {
    return item * 2;
}

let newArray = array.selfMap(mapCallback);
console.log(newArray);

let otherArray = [1, 2, 3, 4, 5];

// let filteredArray = otherArray.filter(funtion(item, index, originalArray) {
//     return item > 2;
// });

Array.prototype.selfFilter = function(callback) {
    let filtered = [];

    for (let i = 0; i < this.length; i++) {
        if (callback(this[i], i, this)) {
            filtered.push(this[i]);
        }
    }
    return filtered;
};

let filteredArray = otherArray.selfFilter(filterCallback);

Array.prototype.selfReduce = function(callback, init) {
    let result = init;

    for (let i = 0; i < this.length; i++) {
        result = callback(result, this[i], i, this);
    }
    return result;
};

let reduceArray = [1, 2, 3, 4, 5, 6];

let result = array.selfReduce(function(result, item) {
    return result + item;
}, 0);

console.log(result);
